/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2008  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PASANGEMAS_BRAINSETTER
#define PASANGEMAS_BRAINSETTER 1
#include <gtkmm/dialog.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/comboboxtext.h>
#include "brain.h"

namespace Pasang {

class BrainSetter {
  private:
    enum {
      INDEX_TIME_ADJUSTMENT = 0,
      INDEX_DEPTH_ADJUSTMENT = 1,
      INDEX_DISCERNMENT_ADJUSTMENT = 2,
      NUM_ADJUSTMENTS = 3
    };
    Gtk::Dialog       *dialog;
    Gtk::Adjustment   *adjustments[NUM_ADJUSTMENTS];
    Gtk::ComboBoxText *name_list;
    bool               auto_adjusting;  // To prevent a chain reaction of change signals
    
  public:
    BrainSetter ();
    ~BrainSetter ();
    bool          show_dialog (char* title, Gtk::Window&, VirtualPlayer&);
    Glib::ustring get_name (VirtualPlayer&);
    
  private:
    void          make_dialog ();
    Glib::ustring tick_label (double, int id);
    void          on_value_changed ();
    void          on_name_changed ();
};

}; //end namespace
#endif

// vim: tabstop=2: expandtab: textwidth=100: autoindent:
