/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2008  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "window.h"
#include <glibmm/thread.h>
#include <gtkmm/main.h>
#include <libgnomeui/gnome-ui-init.h>

using namespace Pasang;

int main(int argc, char *argv[])
{
  if (argc == 2) {
    if (strcmp (argv[1], "--themes-path") == 0) {
      printf ("%s", THEME_ROOT_DIR);
    }
    else {
      printf ("Usage:\n%s\n", "  " PACKAGE_TARNAME "\n  " PACKAGE_TARNAME " --themes-path");
    }
    return 0;
  }
  
  // Localisation stuff
  setlocale (LC_ALL, NULL);
#ifdef DFASDFADSFASDFADFASDFASDFASDFASDFASDFAfadsfasd
  /* Change language.  */
  setenv ("LANGUAGE", "ms", 1);

  /* Make change known.  */
  {
    extern int  _nl_msg_cat_cntr;
    ++_nl_msg_cat_cntr;
  }  
#endif
  bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, LOCALEDIR);
  textdomain (GETTEXT_PACKAGE);
  // printf ("package:%s\nlocaledir:%s\ndatadir:%s\n", PACKAGE_STRING, LOCALEDIR, DATADIR);
  // Main stuff
  Glib::thread_init ();

  GnomeProgram* _program = gnome_program_init (PACKAGE, VERSION, 
                           LIBGNOMEUI_MODULE, argc, argv,
                           GNOME_PROGRAM_STANDARD_PROPERTIES, NULL);

  Gtk::Main kit (argc, argv);
  Window window;
  Gtk::Main::run (window);

  return 0;
}

// vim: tabstop=2: expandtab: textwidth=100: autoindent:
