/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2008  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PASANGEMAS_MOVE
#define PASANGEMAS_MOVE 1
#include "pasang-emas.h"

namespace Pasang {

class Move {             // Generated by Board::generate_branches
  public:
    int position;        // For stage==STAGE_OPENING,    column selected (1-11)
                         // For stage==STAGE_SELECT_KAS, position from which the kas appears
                         // For stage==STAGE_MOVE_KAS,   position onto which the kas moves
    int id;              // The index of this Move in the originally constructed list of moves
    int score;           // Not used by this class. Provided here for the program's AI
    
  private:
    GameStageType stage;         // The stage when this move was generated/made
    int booty_positions[MATRIX_WIDTH];
    int num_booties;
    int value;                   // Used for to_string() only
    int player;                  // Used for to_string() only
    
  public:
    Move ();
    std::string to_string () const;
    void        set (GameStageType, int player, int id, int position); 
    void        add_booty (int booty_position, PieceType); 
    int         count_booties () const;
    int         get_booty_position (int n) const;
};

}; //end namespace
#endif

// vim: tabstop=2: expandtab: textwidth=100: autoindent:
