/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2008  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PASANGEMAS_RECORDING
#define PASANGEMAS_RECORDING 1
#include "pasang-emas.h"
#include "board.h"

namespace Pasang {

class Recording {
  private:
    enum {MAX_MOVE = MATRIX_SIZE}; // A game cannot possibly be longer than MATRIX_SIZE
    // It's more efficient to store the move indices rather than the string representations.
    // But someday (dreaming again) this class may be used to read games from files.
    std::string* move_notations;
    int          num_moves;
    Board        initial_board;
    
  public:
    Recording ();
    ~Recording ();
    void record (Board& initial_board);
    void record (std::string& move);
    void undo (Board& resulting_board);
};

};//end namespace
#endif

// vim: tabstop=2: expandtab: textwidth=100: autoindent:
